"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ReactUpdates = require("react/lib/ReactUpdates");

var _ReactUpdates2 = _interopRequireDefault(_ReactUpdates);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SOURCE_NONE = -1;
var SOURCE_FUNCTION = 0;
var SOURCE_PROMISE = 1;

var GENERATOR_FUNCTION = "GeneratorFunction";
var GENERATOR_OBJECT = "[object Generator]";

var BatchingStrategy = function () {
  function BatchingStrategy() {
    _classCallCheck(this, BatchingStrategy);

    this._source = SOURCE_NONE;
    this._promise = null;
  }

  _createClass(BatchingStrategy, [{
    key: "batchedUpdates",
    value: function batchedUpdates(callback, a, b, c, d, e) {
      if (callback instanceof Function) {
        if (GENERATOR_FUNCTION === callback.constructor.name) {
          this._handleGeneratorFunction(callback, a, b, c, d, e);
        } else {
          this._handleFunction(callback, a, b, c, d, e);
        }
      } else if (callback !== null && callback instanceof Object) {
        if (callback instanceof Promise) {
          this._handlePromise(callback);
        } else if (GENERATOR_OBJECT === callback.toString()) {
          this._handleGeneratorObject(callback);
        }
      }
    }
  }, {
    key: "_handlePromise",
    value: function _handlePromise(promiseToHandle) {
      var _this = this;

      if (this._source === SOURCE_PROMISE) {
        (function () {
          var promise = _this._promise = _this._promise.then(function () {
            return promiseToHandle;
          }).catch(function () {
            return null;
          }).then(function () {
            return _this._closePromise(promise);
          });
        })();
      } else {
        (function () {
          _this._source = SOURCE_PROMISE;
          var promise = _this._promise = promiseToHandle.catch(function () {
            return null;
          }).then(function () {
            return _this._closePromise(promise);
          });
        })();
      }
    }
  }, {
    key: "_handleGeneratorFunction",
    value: function _handleGeneratorFunction(callback, a, b, c, d, e) {
      try {
        this._handleGeneratorObject(callback(a, b, c, d, e));
      } catch (_) {
        // ignore
      }
    }
  }, {
    key: "_handleGeneratorObject",
    value: function _handleGeneratorObject(generator) {
      var generatorPromise = new Promise(function (resolve) {
        while (!generator.next().done) {
          // waiting or crashing
        }
        resolve();
      });
      this._handlePromise(generatorPromise);
    }
  }, {
    key: "_handleFunction",
    value: function _handleFunction(callback, a, b, c, d, e) {
      var isBatchingUpdates = this.isBatchingUpdates;
      if (!isBatchingUpdates) {
        this._source = SOURCE_FUNCTION;
      }
      try {
        callback(a, b, c, d, e);
      } catch (_) {
        // ignore
      }
      if (!isBatchingUpdates && this._source === SOURCE_FUNCTION) {
        this._close();
      }
    }
  }, {
    key: "_closePromise",
    value: function _closePromise(promise) {
      if (promise === this._promise) {
        this._promise = null;
        this._close();
      }
    }
  }, {
    key: "_close",
    value: function _close() {
      try {
        _ReactUpdates2.default.flushBatchedUpdates();
      } catch (_) {
        // ignore
      }
      this._source = SOURCE_NONE;
    }
  }, {
    key: "isBatchingUpdates",
    get: function get() {
      return this._source !== SOURCE_NONE;
    }
  }]);

  return BatchingStrategy;
}();

exports.default = BatchingStrategy;